/**
 * description
 *
 * @author eson
 *2022年7月12日-11:10:54
 */
package com.yuandian.dataflow.statemachine.rpc;

import java.nio.ByteBuffer;

import com.alipay.remoting.exception.CodecException;
import com.alipay.remoting.serialization.SerializerManager;
import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.entity.Task;
import com.alipay.sofa.jraft.error.RaftError;
import com.alipay.sofa.jraft.rpc.RpcContext;
import com.alipay.sofa.jraft.rpc.RpcProcessor;
import com.lmax.disruptor.WorkProcessor;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.SyncClosure;
import com.yuandian.dataflow.statemachine.StateServerFactory.StateServer;
import com.yuandian.dataflow.statemachine.state.State;
import com.yuandian.dataflow.statemachine.state.WorkerState;
import com.alipay.sofa.jraft.entity.PeerId;

import org.apache.commons.lang.StringUtils;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

/**
 * description
 *
 * @author eson
 *2022年7月12日-11:10:54
 */
@Slf4j
public class SyncConditionProcessor implements RpcProcessor<RequestCondition> {

    @Override
    public void handleRequest(RpcContext rpcCtx, RequestCondition request) {
   
        log.info("request: {}", request);
        final SyncClosure<State>  closure = new SyncClosure< State>() {
            @Override
            public void run(Status status) {
                rpcCtx.sendResponse(getResponse());
                log.info("{}", status);
            }
        };
    
        StateServerFactory.getStateServer().applyWorkerState(request.getWorkerState(), closure); 
    }

    @Override
    public String interest() {
        return RequestCondition.class.getName();
    }

 
    
}
